// GAME OF CHANCE - ENHANCED EDITION (CARD GAME)
// By Banjo
// banjosbbs@hotmail.com
// www.banjosbbs.blogspot.com
// Version 1.9
//
// CREDITS:
// Original script by Marspank.
// Enhanced Edition script additions and changes by Banjo.
// Opponent images sourced from various free web preview galleries.
// Spanking sounds recorded and edited by Banjo.
// Card sounds from www.freesound.org, edited by Banjo from sounds originally recorded by F4ngy and Trevornau22fv.
//
// COPYRIGHT:
// This script, from http://ss.deviatenow.com, is protected by this licence:
// CC BY-NC-ND, see http://creativecommons.org/licenses/by-nc-nd/4.0/
// This copyright refers only to this script itself; it does not include any other included resources (images, music, sounds, etc.) which remain the property of their owners.
//
// SCRIPT RESOURCES
// This contains a list of files included with the script when published to the SexScripts website
/*
 * Resources
 * scripts/Banjo/gameofchance_ee.groovy
 */
//

//Metadata
setInfos(7, "Game of Chance EE",
	"A spanking card game (requires Game Hub)",
	"Banjo, marspank",
	"v1.9", 0xFFFFFF, "en",
	["spanking", "game", "femaledom", "formale", "forfemale", "banjohub"]);

//Player setup
def player = (loadString("intro.name"))
def manlady = "man"
def boygirl = "boy"
def bratbitch = "brat"
def cockpussy = "cock"
if(loadBoolean("intro.female"))
{
	manlady = "lady"
	boygirl = "girl"
	bratbitch = "bitch"
	cockpussy = "pussy"
}

//Game Setup
def gamename = "Game of Chance"
def opponent_met = false
def opponent_played = false
def menu = 0
def quit = false
def greeting = "Ready to play?"
def jokerSpanks = 10
def noMatchSpanks = 4
def jokerreshuffle = true
def jokerChance = 4

//Load Settings
def loadSettings = {
	if(loadBoolean("Banjo.gameofchance.custom")) {
		jokerSpanks = loadInteger("Banjo.gameofchance.jokerSpanks")
		noMatchSpanks = loadInteger("Banjo.gameofchance.noMatchSpanks")
		jokerChance = loadInteger("Banjo.gameofchance.jokerChance")
		jokerreshuffle = loadBoolean("Banjo.gameofchance.jokerreshuffle")
	}
}

//Default implements
def baseImplement = "hairbrush"
def jokerImplement = "bathbrush"
def baseImplementSound = "smack"
def jokerImplementSound = "whack"
def swatsBasePlural = "swats"
def swatsJokerPlural = "swats"
def pluralSpanks = {
	if(noMatchSpanks==1) swatsBasePlural = "swat"
	if(jokerSpanks==1) swatsJokerPlural = "swat"
}

//Default opponent
def opponent="Gemma"
def opponent_pics = 5
def opponent_pics2 = 2
def respectTitle = "Miss"
def meet1 = "Hi, I'm "+opponent+"."
def meet2 = "\n\nWhat's your name?"
def meet3 = "It's nice to meet you, "+player+"."
def meet4 = "Let's play '"+gamename+"'."
def intro1 = "Hi there!\n\nLet's play '"+gamename+"'."
def backagain1 = "Want to play '"+gamename+"' with me again?"
def backagain2 = "Back for another game of '"+gamename+"'?"
def refuse1 = "Aww, too bad!\n\nMaybe some other time?"
def goodbye1 = "Now wasn't that a fun game?\n\nCome back soon so we can play again."

//Opponents
def maxOpponents = 13
def opponent0 = "Gemma"
def opponent1 = "Sandy"
def opponent2 = "Khyanna"
def opponent3 = "Raven"
def opponent4 = "Nicole"
def opponent5 = "Gracie"
def opponent6 = "Melanie"
def opponent7 = "Ann"
def opponent8 = "Valentina"
def opponent9 = "Kitty"
def opponent10 = "Bryci"
def opponent11 = "Tyler"
def opponent12 = "Tere"
def opponent13 = "Kiara"

def opponentSet0 = {
	opponent = "Gemma"
	respectTitle = "Miss"
	opponent_pics = 5
	opponent_pics2 = 2
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet1 = {
	opponent = "Sandy"
	respectTitle = "Miss"
	opponent_pics = 5
	opponent_pics2 = 2
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet2 =  {
	opponent = "Khyanna"
	respectTitle = "Miss"
	opponent_pics = 5
	opponent_pics2 = 2
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet3 = 	{
	opponent = "Raven"
	respectTitle = "Miss"
	opponent_pics = 7
	opponent_pics2 = 2
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet4 = {
	opponent = "Nicole"
	respectTitle = "Miss"
	opponent_pics = 4
	opponent_pics2 = 2
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet5 = {
	opponent = "Gracie"
	respectTitle = "Miss"
	opponent_pics = 5
	opponent_pics2 = 2
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet6 = {
	opponent = "Melanie"
	respectTitle = "Miss"
	opponent_pics = 6
	opponent_pics2 = 2
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet7 = {
	opponent = "Ann"
	respectTitle = "Miss"
	opponent_pics = 7
	opponent_pics2 = 3
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet8 = {
	opponent = "Valentina"
	respectTitle = "Miss"
	opponent_pics = 4
	opponent_pics2 = 2
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet9 = {
	opponent = "Kitty"
	respectTitle = "Miss"
	opponent_pics = 7
	opponent_pics2 = 2
	meet1 = "My name is "+opponent+"."
	meet2 = "\n\nWho the hell are you, "+bratbitch+"?"
	meet3 = "Hmph! Another silly little "+boygirl+"?"
	meet4 = "I assume you want to play '"+gamename+"' with me?"
	intro1 = "Hello, "+boygirl+"\n\nShall we play '"+gamename+"'?"
	backagain1 = "Do you want to play '"+gamename+"' again?"
	backagain2 = "Back for another game of '"+gamename+"', "+boygirl+"?"
	refuse1 = "Then run along and don't bother me, little "+boygirl+"."
	goodbye1 = "That was rather amusing.\n\nI might enjoy playing with you again."
}

def opponentSet10 = {
	opponent = "Bryci"
	respectTitle = "Miss"
	opponent_pics = 5
	opponent_pics2 = 3
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet11 = {
	opponent = "Tyler"
	respectTitle = "Miss"
	opponent_pics = 4
	opponent_pics2 = 2
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet12 = {
	opponent = "Tere"
	respectTitle = "Miss"
	opponent_pics = 7
	opponent_pics2 = 4
	meet1 = "Hi, I'm "+opponent+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

def opponentSet13 = {
	opponent = "Kiara"
	respectTitle = "Aunty"
	opponent_pics = 7
	opponent_pics2 = 4
	meet1 = "Hello there. I'm "+opponent+"... but you can call me '"+respectTitle+" "+opponent+"', young "+manlady+"."
	meet2 = meet2
	meet3 = meet3
	meet4 = meet4
	intro1 = intro1
	backagain1 = backagain1
	backagain2 = backagain2
	refuse1 = refuse1
	goodbye1 = goodbye1
}

//Opponent selection menu
def opponentSelect = {
	def opponentselection = true
	while(opponentselection)
	{
		def pick_opponent = getSelectedValue("Select your opponent:", [opponent0,opponent1,opponent2,opponent3,opponent4,opponent5,opponent6,opponent7,opponent8,opponent9,opponent10,opponent11,opponent12,opponent13])
		if(pick_opponent==0) opponentSet0()
		else if(pick_opponent==1) opponentSet1()
		else if(pick_opponent==2) opponentSet2()
		else if(pick_opponent==3) opponentSet3()
		else if(pick_opponent==4) opponentSet4()
		else if(pick_opponent==5) opponentSet5()
		else if(pick_opponent==6) opponentSet6()
		else if(pick_opponent==7) opponentSet7()
		else if(pick_opponent==8) opponentSet8()
		else if(pick_opponent==9) opponentSet9()
		else if(pick_opponent==10) opponentSet10()
		else if(pick_opponent==11) opponentSet11()
		else if(pick_opponent==12) opponentSet12()
		else if(pick_opponent==13) opponentSet13()
		if(pick_opponent<(maxOpponents+1)) opponentselection = false
	}
}

//Config menu
def setCustom = {
	noMatchSpanks = getInteger("Enter the number of spanks you get per failed match attempt.\n\n(default is 4, current is "+noMatchSpanks+")",4)
	while(noMatchSpanks<1) {
		noMatchSpanks = getInteger("You must set the number of spanks to at least 1.\n\n(default is 4)",4)
	}
	jokerChance = getInteger("Enter the number of Jokers you want in the deck.\n\n(default is 4, current is "+jokerChance+")",4)
	if(jokerChance>0) {
		jokerSpanks = getInteger("Enter the number of spanks you get when a Joker is drawn.\n\n(default is 10, current is "+jokerSpanks+")",10)
		while(jokerSpanks<1) {
			jokerSpanks = getInteger("You must set the number of Joker spanks to at least 1.\n\n(default is 10)",10)
		}
		jokerreshuffle = getBoolean("Do you want to reshuffle the deck when a Joker is drawn?\n\n(default is true, current is "+jokerreshuffle+")","True","False")
	}
	pluralSpanks()
	save("Banjo.gameofchance.noMatchSpanks",noMatchSpanks)
	save("Banjo.gameofchance.jokerSpanks",jokerSpanks)
	save("Banjo.gameofchance.jokerChance",jokerChance)
	save("Banjo.gameofchance.jokerreshuffle",jokerreshuffle)
	save("Banjo.gameofchance.custom",true)
	show("Settings saved.")
	wait(3)
	loadSettings()
}

def resetGame = {
	noMatchSpanks = 4
	jokerSpanks = 10
	jokerreshuffle = true
	jokerChance = 4
	opponent_played = false
	save("Banjo.gameofchance.implements_set",false)
	save("Banjo.gameofchance.noMatchSpanks",noMatchSpanks)
	save("Banjo.gameofchance.jokerSpanks",jokerSpanks)
	save("Banjo.gameofchance.jokerChance",jokerChance)
	save("Banjo.gameofchance.jokerreshuffle",jokerreshuffle)
	save("Banjo.gameofchance.custom",false)
	save("Banjo.gameofchance.played_"+opponent0+"",opponent_played)
	save("Banjo.gameofchance.played_"+opponent1+"",opponent_played)
	save("Banjo.gameofchance.played_"+opponent2+"",opponent_played)
	save("Banjo.gameofchance.played_"+opponent3+"",opponent_played)
	save("Banjo.gameofchance.played_"+opponent4+"",opponent_played)
	save("Banjo.gameofchance.played_"+opponent5+"",opponent_played)
	save("Banjo.gameofchance.played_"+opponent6+"",opponent_played)
	save("Banjo.gameofchance.played_"+opponent7+"",opponent_played)
	save("Banjo.gameofchance.played_"+opponent8+"",opponent_played)
	save("Banjo.gameofchance.played_"+opponent9+"",opponent_played)
	save("Banjo.gameofchance.played_"+opponent10+"",opponent_played)
	save("Banjo.gameofchance.played_"+opponent11+"",opponent_played)
	save("Banjo.gameofchance.played_"+opponent12+"",opponent_played)
	save("Banjo.gameofchance.played_"+opponent13+"",opponent_played)
	show("Settings reset to defaults.\n\nGame will quit after exiting config.")
	wait(5)
	quit = true
}

def resetTotal = {
	noMatchSpanks = 4
	jokerSpanks = 10
	jokerreshuffle = true
	jokerChance = 4
	opponent_met = false
	opponent_played = false
	save("Banjo.gameofchance.implements_set",false)
	save("Banjo.gameofchance.noMatchSpanks",noMatchSpanks)
	save("Banjo.gameofchance.jokerSpanks",jokerSpanks)
	save("Banjo.gameofchance.jokerChance",jokerChance)
	save("Banjo.gameofchance.jokerreshuffle",jokerreshuffle)
	save("Banjo.gameofchance.custom",false)
	save("Banjo.gameofchance.played_"+opponent0+"",opponent_played)
	save("Banjo.gameofchance.played_"+opponent1+"",opponent_played)
	save("Banjo.gameofchance.played_"+opponent2+"",opponent_played)
	save("Banjo.gameofchance.played_"+opponent3+"",opponent_played)
	save("Banjo.gameofchance.played_"+opponent4+"",opponent_played)
	save("Banjo.gameofchance.played_"+opponent5+"",opponent_played)
	save("Banjo.gameofchance.played_"+opponent6+"",opponent_played)
	save("Banjo.gameofchance.played_"+opponent7+"",opponent_played)
	save("Banjo.gameofchance.played_"+opponent8+"",opponent_played)
	save("Banjo.gameofchance.played_"+opponent9+"",opponent_played)
	save("Banjo.gameofchance.played_"+opponent10+"",opponent_played)
	save("Banjo.gameofchance.played_"+opponent11+"",opponent_played)
	save("Banjo.gameofchance.played_"+opponent12+"",opponent_played)
	save("Banjo.gameofchance.played_"+opponent13+"",opponent_played)
	save("Banjo.games.met_"+opponent0+"",opponent_met)
	save("Banjo.games.met_"+opponent1+"",opponent_met)
	save("Banjo.games.met_"+opponent2+"",opponent_met)
	save("Banjo.games.met_"+opponent3+"",opponent_met)
	save("Banjo.games.met_"+opponent4+"",opponent_met)
	save("Banjo.games.met_"+opponent5+"",opponent_met)
	save("Banjo.games.met_"+opponent6+"",opponent_met)
	save("Banjo.games.met_"+opponent7+"",opponent_met)
	save("Banjo.games.met_"+opponent8+"",opponent_met)
	save("Banjo.games.met_"+opponent9+"",opponent_met)
	save("Banjo.games.met_"+opponent10+"",opponent_met)
	save("Banjo.games.met_"+opponent11+"",opponent_met)
	save("Banjo.games.met_"+opponent12+"",opponent_met)
	save("Banjo.games.met_"+opponent13+"",opponent_met)
	show("Settings reset to defaults.")
	wait(5)
	quit = true
}

def changeSettings = {
	def loopmenu = true
	while(loopmenu) {
		menu = getSelectedValue("What do you want to do?", ["Exit Config", "Customize", "Reset Game", "Total Reset"])
		if(menu==0) loopmenu = false
		else if(menu==1) setCustom()
		else if(menu==2) resetGame()
		else if(menu==3) resetTotal()
	}
}

//Card Sounds
def playSoundCardShuffle = {
	playSound("banjo/casino/card_shuffle.wav")
}

def playSoundCardDeal = {
	playSound("banjo/casino/card_deal.wav")
}

//Basic variables and definitions
def int startSuit = -1
def int startValue = -1
def matchSuit
def matchValue
def matchFound = false

def suitArray = ["Hearts","Diamonds","Spades","Clubs",""]
def faceArray = ["Ace","2","3","4","5","6","7","8","9","10","Jack","Queen","King",""]

def int cardValue
def int suit

def dealt

def shuffle = {
	playSoundCardShuffle()
	for(i in 0..51+jokerChance)
	{
		dealt[i] = false
	}
	if(startSuit != -1)
	{
		dealt[startSuit*13+startValue] = true
	}
}

def drawNextCard = {
	def randomCard = getRandom(52+jokerChance)
	if(randomCard > 51) //This represents a joker
	{
		cardValue = 13
		dealt[randomCard] = true  //set specific joker to dealt for option of not shuffling with jokers
	}
	else //Find out what card is drawn
	{
		cardValue = randomCard % 13
		suit = randomCard / 13
		while(dealt[suit*13+cardValue])
		{
			cardValue = getRandom(14)
			suit = getRandom(4)
		}
		dealt[suit*13+cardValue] = true
	}
}

def getRandomItem = { itemKeys ->
	for ( key in itemKeys ) {
		if ( !loadBoolean(key) ) itemKeys -= key
	}
	if ( itemKeys.isEmpty() ) return null
	return itemKeys[ getRandom(itemKeys.size()) ]
}

def spankImplement = baseImplement
def spankSound = baseImplementSound
def spankSoundLimit = 4

def x = 0
def spank = {
	message, spanks, time ->
	show(""+message+"\n\n. . ")
	wait(2)
	(1..spanks).each {
		x++
		show(message+"\n\n."+x+".")
		playBackgroundSound("spanks/"+spankSound+(1+getRandom(spankSoundLimit))+".wav")
		wait(time)
	}
	wait(5)
	x = 0
}

def clothesState = 1

//Randomly select an image
def setImageGame = {
	def imageNumber = getRandom(opponent_pics)+1
	setImage("opponents/"+opponent+"_playing"+imageNumber+".jpg")
}

def setImageSpank = {
	def imageNumber = getRandom(opponent_pics2)+1
	setImage("opponents/"+opponent+"_spank"+imageNumber+".jpg")
}

//Show main opponent image
def setImageMain = {
	setImage("opponents/"+opponent+"_intro.jpg")
}

//Fancy image transitions
def imageSpeed = 20
def setImageFancy = { picture ->
	if (imageSpeed <= 0) imageSpeed = 0.1
	def image = java.awt.Toolkit.getDefaultToolkit().getImage("images/"+picture)
	def width = image.getWidth()
	def height = image.getHeight()
	
	(1..10).each {
		def frameBuffer = new java.awt.image.BufferedImage( (int)((width*it)/10), (int)((height*it)/10),
 							  java.awt.image.BufferedImage.TYPE_4BYTE_ABGR)
		def sprite = javax.imageio.ImageIO.read(new File("images/"+picture))
	
		java.awt.Graphics2D graphics = frameBuffer.createGraphics()
	
		graphics.drawImage(sprite, 0, 0, (int)((width*it)/10), (int)((height*it)/10), null)
	
		setImage(frameBuffer, false)
		wait(1/imageSpeed)
	}
}
def setImageOffFancy = { picture ->
	if (imageSpeed <= 0) imageSpeed = 0.1
	def image = java.awt.Toolkit.getDefaultToolkit().getImage("images/"+picture)
	def width = image.getWidth()
	def height = image.getHeight()
	
	(1..10).each {
		def frameBuffer = new java.awt.image.BufferedImage( (int)(width/it), (int)(height/it),
 							  java.awt.image.BufferedImage.TYPE_4BYTE_ABGR)
		def sprite = javax.imageio.ImageIO.read(new File("images/"+picture))
	
		java.awt.Graphics2D graphics = frameBuffer.createGraphics()
	
		graphics.drawImage(sprite, 0, 0, (int)(width/it), (int)(height/it), null)
	
		setImage(frameBuffer, false)
		wait(1/imageSpeed)
	}
	setImage(null)
}

//Game Intro
def intro = {
	if(!loadBoolean("Banjo.games.met_"+opponent+"")) {
		opponent_met = false
		save("Banjo.games.met_"+opponent+"",true)
	} else opponent_met = true
	if(!loadBoolean("Banjo.gameofchance.played_"+opponent+"")) {
		opponent_played = false
		save("Banjo.gameofchance.played_"+opponent+"",true)
	} else opponent_played = true
	if(!opponent_met) {
		show(meet1+meet2)
		showButton("I'm "+player+", "+respectTitle+".")
		show(meet3)
		wait(3)
		greeting = meet4
	} else if(!opponent_played) {
		greeting = intro1
	} else {
		def backagainMessageArray = [backagain1,backagain2]
		greeting = backagainMessageArray[getRandom(2)]
	}
	def mainmenu = true
	while(mainmenu) {
		loadSettings()
		menu = getSelectedValue(greeting, ["Yes", "No", "Config"])
		if(menu==0)
			mainmenu = false
		else if(menu==1) {
			show(refuse1)
			wait(5)
			mainmenu = false
			quit = true
		}
		else if(menu==2)
			changeSettings()
	}
}

//Rules explaination
def rulesDisplay = {
	show("'"+gamename+"' is a spanking card-matching game.")
	showButton("Sounds interesting, "+respectTitle+".")
	show("At the start of the game, you shuffle the deck and draw the top card.\n\n"
		+"You then have to draw cards from the deck until you match your initial card.")
	showButton("I see, "+respectTitle+".")
	show("It won't be easy!\n\nThe card you need to find to match your "
		+"initial card not only has to have the same face value, but it has to be the "
		+"same colour too!")
	showButton("But that means...")
	show("Yes, "+player+"... since the first card you drew has already been removed, "
		+"that means there is only ONE possible match for you to find left in the deck!")
	showButton("Only one, "+respectTitle+"?")
	show("Correct.\n\n"
		+"But here's where things get fun!\n\nEvery card drawn that is not the correct "
		+"match will earn you "+noMatchSpanks+" "+swatsBasePlural+"!")
	showButton("Ouch, "+respectTitle+"!")
	if(jokerChance>0) {
		show("But that isn't even the best part. Well, the best part for me.\n\n"
			+"You see, there are also "+jokerChance+" Joker cards in the deck...")
		showButton("Jokers?")
		show("Yes, Jokers.\n\nWhenever you draw a Joker, you get "+jokerSpanks+" "+swatsJokerPlural+"... "
			+"and with a more severe implement, too!")
		showButton("Uh oh...")
		if(jokerreshuffle==true)
		{
			show("Oh, and I almost forgot to mention...\n\nEvery time you draw a Joker, all the cards "
				+"you have drawn (except for your initial card) are shuffled back into the deck!")
			showButton("(Gulp!)")
		}
	}
}

//Implement sound assignments
def setImplementSound = {
	if(spankImplement=="hairbrush") spankSound = "smack"
	else if(spankImplement=="paddle hairbrush") spankSound = "smack"
	else if(spankImplement=="plastic hairbrush") spankSound = "slap"
	else if(spankImplement=="ruler") spankSound = "whap"
	else if(spankImplement=="spatula") spankSound = "slap"
	else if(spankImplement=="wooden spatula") spankSound = "slap"
	else if(spankImplement=="flyswatter") spankSound = "slap"
	else if(spankImplement=="wooden spoon") spankSound = "whap"
	else if(spankImplement=="bathbrush") spankSound = "whack"
	else if(spankImplement=="slipper") spankSound = "smack"
	else if(spankImplement=="sandal") spankSound = "smack"
	else if(spankImplement=="plimsoll") spankSound = "smack"
	else if(spankImplement=="sneaker") spankSound = "smack"
	else if(spankImplement=="leather slapper") spankSound = "slap"
	else if(spankImplement=="leather paddle") spankSound = "slap"
	else if(spankImplement=="table tennis bat") spankSound = "smack"
	else if(spankImplement=="paddleball bat") spankSound = "smack"
	else if(spankImplement=="battledore bat") spankSound = "whack"
	else if(spankImplement=="beach tennis bat") spankSound = "smack"
	else if(spankImplement=="paddle") spankSound = "whack"
	else if(spankImplement=="paddle with holes") spankSound = "whack"
	else if(spankImplement=="lexan paddle") spankSound = "whack"
	else if(spankImplement=="plastic paddle") spankSound = "smack"
	else if(spankImplement=="rubber paddle") spankSound = "smack"
	else if(spankImplement=="strap") spankSound = "belt"
	else if(spankImplement=="studded strap") spankSound = "belt"
	else if(spankImplement=="loop strap") spankSound = "slap"
	else if(spankImplement=="belt") spankSound = "belt"
	else if(spankImplement=="tawse") spankSound = "flog"
	else if(spankImplement=="cane") spankSound = "thwack"
	else if(spankImplement=="judicial cane") spankSound = "thwack"
	else if(spankImplement=="duster handle") spankSound = "thwack"
	else if(spankImplement=="short cane") spankSound = "thwack"
	else if(spankImplement=="plastic cane") spankSound = "thwack"
	else if(spankImplement=="loop cane") spankSound = "thwack"
	else if(spankImplement=="riding crop") spankSound = "thwip"
	else if(spankImplement=="birch rod") spankSound = "thwip"
	else if(spankImplement=="curtain rod") spankSound = "thwip"
	else if(spankImplement=="switch") spankSound = "thwip"
	else if(spankImplement=="rugbeater") spankSound = "thwack"
	else if(spankImplement=="martinet") spankSound = "thwip"
	else if(spankImplement=="flogger") spankSound = "flog"
	else if(spankImplement=="cat-o-nine-tails") spankSound = "flog"
	else if(spankImplement=="whip") spankSound = "flog"
	else spankSound="smack"
}

def setImplementSounds = {
	spankImplement = baseImplement
	setImplementSound()
	baseImplementSound = spankSound
	spankImplement = jokerImplement
	setImplementSound()
	jokerImplementSound = spankSound
}

//Mistress chooses implements
def pickImplementsMistress = {
	def implement
	//Base
	def toysBase = ["toys.ruler","toys.wooden_spoon","toys.spatula","toys.spatula_wooden","toys.flyswatter",
		"toys.slipper","toys.sandal","toys.plimsoll","toys.sneaker",
		"toys.slapper","toys.strap_loop","toys.paddle_leather","toys.paddle_plastic",
		"toys.bat","toys.bat_flyback","toys.bat_battledore","toys.bat_beach",
		"toys.hairbrush","toys.hairbrush_plastic","toys.hairbrush_paddle"]
	implement = getRandomItem(toysBase)
	if(implement == "toys.ruler") baseImplement = "ruler"
	else if(implement == "toys.wooden_spoon") baseImplement = "wooden spoon"
	else if(implement == "toys.spatula") baseImplement = "spatula"
	else if(implement == "toys.spatula_wooden") baseImplement = "spatula"
	else if(implement == "toys.flyswatter") baseImplement = "flyswatter"
	else if(implement == "toys.slipper") baseImplement = "slipper"
	else if(implement == "toys.sandal") baseImplement = "sandal"
	else if(implement == "toys.plimsoll") baseImplement = "plimsoll"
	else if(implement == "toys.sneaker") baseImplement = "sneaker"
	else if(implement == "toys.slapper") baseImplement = "leather slapper"
	else if(implement == "toys.strap_loop") baseImplement = "looped strap"
	else if(implement == "toys.paddle_leather") baseImplement = "leather paddle"
	else if(implement == "toys.paddle_plastic") baseImplement = "plastic paddle"
	else if(implement == "toys.bat") baseImplement = "table tennis bat"
	else if(implement == "toys.bat_flyback") baseImplement = "paddleball bat"
	else if(implement == "toys.bat_jokari") baseImplement = "battledore bat"
	else if(implement == "toys.bat_beach") baseImplement = "beach tennis bat"
	else if(implement == "toys.hairbrush") baseImplement = "hairbrush"
	else if(implement == "toys.hairbrush_paddle") baseImplement = "hairbrush"
	else if(implement == "toys.hairbrush_plastic") baseImplement = "plastic hairbrush"
	if(implement == null) baseImplement = getString("You don't have any of the implements I was looking for.\n\nEnter the one you want for normal cards", "hairbrush")
	//Joker
	def toysJoker = ["toys.paddle","toys.paddle_holes","toys.paddle_lexan","toys.bathbrush",
		"toys.strap","toys.strap_studded","toys.belt","toys.tawse","toys.paddle_rubber",
		"toys.crop","toys.switch","toys.birch","toys.rugbeater","toys.rod","toys.duster",
		"toys.cane","toys.cane_heavy","toys.cane_otk","toys.cane_plastic","toys.cane_loop",
		"toys.martinet","toys.flogger","toys.cat_o_nine","toys.whip"]
	implement = getRandomItem(toysJoker)
	if(implement == "toys.paddle") jokerImplement = "paddle"
	else if(implement == "toys.paddle_holes") jokerImplement = "paddle with holes"
	else if(implement == "toys.paddle_lexan") jokerImplement = "lexan paddle"
	else if(implement == "toys.bathbrush") jokerImplement = "bathbrush"
	else if(implement == "toys.strap") jokerImplement = "strap"
	else if(implement == "toys.strap_studded") jokerImplement = "studded strap"
	else if(implement == "toys.belt") jokerImplement = "belt"
	else if(implement == "toys.tawse") jokerImplement = "tawse"
	else if(implement == "toys.paddle_rubber") jokerImplement = "rubber paddle"
	else if(implement == "toys.crop") jokerImplement = "riding crop"
	else if(implement == "toys.switch") jokerImplement = "switch"
	else if(implement == "toys.birch") jokerImplement = "birch rod"
	else if(implement == "toys.rugbeater") jokerImplement = "rugbeater"
	else if(implement == "toys.rod") jokerImplement = "curtain rod"
	else if(implement == "toys.duster") jokerImplement = "duster handle"
	else if(implement == "toys.cane") jokerImplement = "cane"
	else if(implement == "toys.cane_heavy") jokerImplement = "judicial cane"
	else if(implement == "toys.cane_otk") jokerImplement = "short cane"
	else if(implement == "toys.cane_plastic") jokerImplement = "plastic cane"
	else if(implement == "toys.cane_loop") jokerImplement = "loop cane"
	else if(implement == "toys.martinet") jokerImplement = "martinet"
	else if(implement == "toys.flogger") jokerImplement = "flogger"
	else if(implement == "toys.cat_o_nine") jokerImplement = "cat-o-nine-tails"
	else if(implement == "toys.whip") jokerImplement = "whip"
	if(implement == null) jokerImplement = getString("You don't have any of the implements I was looking for.\n\nEnter the one you want for Jokers", "bathbrush")
}

//Player chooses implements
def pickImplementsPlayer = {
	baseImplement = getString("Enter the implement you want for normal cards", "hairbrush")
	jokerImplement = getString("Enter the implement you want for Jokers", "bathbrush")
}

//Implement selection
def pickImplementsChoice = {
	if(getBoolean("Do you want to me to pick the implements for you, based on what you have?\n\nOr do you want to choose them yourself?",
	"You pick","I'll pick")) pickImplementsMistress()
	else pickImplementsPlayer()
}

def pickImplements = {
	pickImplementsChoice()
	setImplementSounds()
	save("Banjo.gameofchance.baseImplement",baseImplement)
	save("Banjo.gameofchance.jokerImplement",jokerImplement)
	save("Banjo.gameofchance.implements_set",true)
	show("Okay. The implements we're going to be using are:\n"
		+"\n\tBase Implement: "+baseImplement+"."
		+"\n\tJoker Implement: "+jokerImplement+".")
	showButton("I have them ready, "+respectTitle+".")
}

//Game round
def gameRound = {
	
	setImageGame()
	while(!matchFound)
	{
		drawNextCard()
		playSoundCardDeal()
		//Card drawn is a Joker
		if(cardValue == 13)
		{
			show("Oh no! You drew a Joker!")
			wait(5)
			show("Time for some "+jokerImplement+" spanks!")
			spankSound=jokerImplementSound
			wait(10)
			setImageSpank()
			spank("Spank your butt hard!",jokerSpanks,1)
			setImageGame()
			if(jokerreshuffle==true)
			{
				show("Now I get to reshuffle the deck...")
				shuffle()
			}
			show("And draw your next card...")
			wait(5)
		}
		else if(cardValue == matchValue && suit == matchSuit)
		{
			matchFound = true
			show("You drew the "+faceArray[cardValue]+" of "+suitArray[suit]+".")
			wait(5)
			show("Hey, lucky you! That's your match card. Hope it didn't take you too long to find.")
			showButton("Thank you, "+respectTitle+".")
		}
		else
		{
			show("You drew the "+faceArray[cardValue]+" of "+suitArray[suit]+".")
			wait(5)
			show("No match."
				+"\n\nThat means "+noMatchSpanks+" "+swatsBasePlural+" with the "+baseImplement+".")
			spankSound=baseImplementSound
			wait(5)
			setImageSpank()
			if(noMatchSpanks==1) spank("Make it a hard one.",noMatchSpanks,1)
			else if(noMatchSpanks==2) spank("One hard swat on each cheek.",noMatchSpanks,1)
			else spank("Alternate cheeks, hard swats.",noMatchSpanks,1)
			setImageGame()
			show("Let's draw your next card...")
			wait(5)
		}
	}
	
}

//Starting card draw
def startingCard = {
	show("Now, let's draw your starting card...")
	wait(3)
	
	def randomCard = getRandom(52+jokerChance)
	
		while(randomCard > 51) //This represents a joker
		{
			playSoundCardDeal()
			show("Wow, that's an unlucky start to the game:\n\nYou drew a Joker!")
			wait(5)
			setImageSpank()
			show("Get the "+jokerImplement+" and stick out that butt.")
			spankSound=jokerImplementSound
			showButton("Ready, "+respectTitle+".")
			if(jokerSpanks==1) spank("Good and hard!",jokerSpanks,1)
			else spank("Hard "+swatsJokerPlural+" only!",jokerSpanks,1)
			setImageGame()
			dealt[randomCard] = true  //set specific joker to dealt for option of not shuffling with jokers
			while(dealt[randomCard]) randomCard = getRandom(52+jokerChance)
			if(jokerreshuffle) show("And now I get to reshuffle the deck...")
			if(jokerreshuffle) shuffle()
			show("Let's draw another card... hopefully not a Joker this time!")
			wait(3)
		}
		 //Find out what card is drawn
			startValue = randomCard % 13
			startSuit = randomCard / 13
			
			matchValue = startValue
			if(startSuit == 0) matchSuit = 1
			else if(startSuit == 1) matchSuit = 0
			else if(startSuit == 2) matchSuit = 3
			else matchSuit = 2
			playSoundCardDeal()
			show("Your starting card is the "+faceArray[startValue]+" of "+suitArray[startSuit]+"."
				+"\n\nThat means the card you need to find is the "
				+faceArray[matchValue]+" of "+suitArray[matchSuit]+".")
			showButton("I will get it, "+respectTitle+".")
			
			dealt[startSuit*13+startValue] = true
		
	
}

//Starting clothing for player
def startingClothes = {
	clothesState = getRandom(3)
	def startingClothesMessageArray = ["You're going to be getting spanked a lot throughout this game, "+player+", so you'd better strip from the waist down before we begin."
		+"\n\nCome on, get that bottom bare so we can start playing!",
		"Since this game features almost continuous spanking, why don't you remove all your clothes before we begin?"
		+"\n\nOh, but leave your socks on... you look so pathetic and awkward like that!",
		"Since you're going to be getting spanked pretty much constantly, I think you should strip before we begin."
		+"\n\nYes, that means completely naked, "+player+"!"]
	show(startingClothesMessageArray[clothesState])
	showButton("Yes, "+respectTitle+".")
}

//Install Check
def installed = loadBoolean("Banjo.games.installed")
if(installed==null) {
	installed = false
	save("Banjo.games.installed",installed)
}

def coreScript = new File("scripts/Banjo/gamehub.groovy")
if(coreScript.exists()) {
	installed = true
	save("Banjo.games.installed",installed)
}
else {
	installed = false
	save("Banjo.games.installed",installed)
}
if(!installed) {
	show(null)
	setImage(null)
	if(getBoolean("CORE FILES NOT FOUND!\n\n"
		+"This game requires the download of a 'core' pack of opponents, images, sounds and files that is shared by other games in this series."
		+"To download the needed files, simply go to the SexScripts website script database and search for 'Game Hub' (or the script tag 'banjohub').\n\n"
		+"The script downloads can be found at:\n\n"
		+"http://ss.deviatenow.com/scripts.php\n\n"
		+"Apologies for the inconvenience!"
		+"", "Go to Webpage","Exit")) {
			if(isConnected()) {
				useUrl("http://ss.deviatenow.com/scripts.php")
				getString("Your internet browser should have opened the correct download page.\n\n"
					+"If not, please copy the link below and paste it into your web browser.", "http://ss.deviatenow.com/scripts.php")
			}
			else {
				getString("Cannot connect to the internet (your firewall may be blocking this operation)\n\n"
					+"Please copy the link below and paste it into your web browser.", "http://ss.deviatenow.com/scripts.php")
			}
		}
		show(null)
		setImage(null)
		if(loadBoolean("setting.newsetup")) {
			if(loadBoolean("setting.reload")) {
				return "system/welcome"
			}
			else {
				return "system/exit"
			}
		}
		else {
			return null
		}
}

//Start of script
show(null)
setImage(null)
opponentSelect()
show(null)
setImageMain()
wait(1)
intro()
while(!quit) {
	if(getBoolean("Do you want to review the rules?","Yes","I know them"))
	{
		rulesDisplay()
		while(getBoolean("Do you need to go back over the rules again?","Yes","I understand them"))
		{
			rulesDisplay()
		}
	}
	if(loadBoolean("Banjo.gameofchance.implements_set")) {
		baseImplement = loadString("Banjo.gameofchance.baseImplement")
		jokerImplement = loadString("Banjo.gameofchance.jokerImplement")
		setImplementSounds()
		if(getBoolean("The implements we're going to be using are:\n"
			+"\n\tBase Implement: "+baseImplement+"."
			+"\n\tJoker Implement: "+jokerImplement+"."
			+"\n\nDo you want to change these?","Yes please","No thanks")) {
			pickImplements()
		}
	} else {
		show("For this game, we will be using two different implements.\n\nOne for the normal cards,"
			+" and a more severe one for the Jokers.")
		showButton("Okay, "+respectTitle+".")
		pickImplements()
	}
	startingClothes()
	dealt = new boolean[52+jokerChance]
	setImageGame()
	show("First, I'll shuffle the deck...")
	shuffle()
	startingCard()
	show("Let's draw a card and find out...")
	wait(3)
	gameRound()
	setImageMain()
	show(goodbye1)
	showButton("Goodbye, "+respectTitle+".")
	quit = true
}
setImage(null)
show(null)
def quitGame = true
if(loadBoolean("Banjo.games.hub")) {
	if(getBoolean("Return to Game Hub?","Yes","No")) {
		quitGame = false
		save("Banjo.games.hub",false)
		return "Banjo/gamehub"
	} else save("Banjo.games.hub",false)
}
if(quitGame) {
	if(loadBoolean("setting.newsetup")) {
		if(loadBoolean("setting.reload")) {
			return "system/welcome"
		}
		else {
			return "system/exit"
		}
	}
	else {
		return null
	}
}

//END OF SCRIPT
